#include <iostream.h>
struct node
{
   int KeyMin; //   .
   int KeyMax; //   .
   node *Left; //   "" .
   node *Right; //   "" .
};

class TREE
{
  private:
    node *Tree; //   .
    int S;      //     .
    void Search (int,int,node**); 
  public:
    TREE() {Tree = NULL; S = 0;}
    void BuildTree (); //  .
    node** GetTree () {return &Tree;} //  .
    void CleanTree (node **);
    void Vyvod (node **,int);
    int GetCount() { return S;}
    void Count (node **,float);
};

void main ()
{
  TREE A;
  float X;

  A.BuildTree ();
  cout<<"\n :\n";
  A.Vyvod (A.GetTree(),0);
  cout << "\n  : ";
  cin >> X;
  A.Count(A.GetTree(),X);
  cout << "  "<< A.GetCount() <<" ";
  A.CleanTree (A.GetTree());
}

void TREE::BuildTree ()
//    ( ).
// Tree -    .
{
  int k1,k2;
  cout<<"   ...\n";
  cin>>k1;
  cin>>k2;
  Search (k1,k2,&Tree);
}

void TREE::Search (int k1, int k2, node **p)
// p p p p.
// p -    .
{
  if (k2-k1>1)
  {
    *p = new (node);
    (**p).KeyMin = k1;
    (**p).KeyMax = k2;
    (**p).Left = (**p).Right = NULL;
    Search (k1,(k1+k2)/2,&((**p).Left));
    Search ((k1+k2)/2,k2,&((**p).Right));
  }
  else
  {
    *p = new (node);
    (**p).KeyMin = k1;
    (**p).KeyMax = k2;
    (**p).Left = (**p).Right = NULL;
  }
}

void TREE::Count (node **p, float X)
//   p p p, 
// p  X.
{
  if  (*p!=NULL)
  {
    Count (&((**p).Right),X);
    if  (X>=(**p).KeyMin && X<=(**p).KeyMax)  S++;
    Count (&((**p).Left),X);
  }
}

void TREE::CleanTree (node **w)
// .
//*w -    .
{
  if  (*w!=NULL)
  { CleanTree (&((**w).Left));
    CleanTree (&((**w).Right));
    delete *w; }
}

void TREE::Vyvod (node **w,int l)
//  *w   
//          ( ).
//*w -    .
{
  int i;

  if  (*w!=NULL)
  { Vyvod (&((**w).Right),l+1);
    for  (i=1; i<=l; i++) cout<<"   ";
    cout<<(**w).KeyMin<<", "<<(**w).KeyMax<<endl;
    Vyvod (&((**w).Left),l+1); }
}